=== debian/changelog ===
neovim-qt (0.2.18-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:00:37 +1100

neovim-qt (0.2.18-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:02:38 +0000

neovim-qt (0.2.18-1) unstable; urgency=medium

  * New upstream release
  * Explicitly enable testing based on whether nocheck is present

 -- James McCoy <jamessan@debian.org>  Sat, 27 Jan 2024 13:13:42 -0500

neovim-qt (0.2.17-3) unstable; urgency=medium

  * Upload to unstable
  * Remove generated files during clean (Closes: #1045495)
  * Generate API bindings pre-configure to ensure they're available when CMake
    is run.
  * Add explicit python3 Build-Depends

 -- James McCoy <jamessan@debian.org>  Fri, 18 Aug 2023 09:01:45 -0400

neovim-qt (0.2.17-2) experimental; urgency=medium

  * Add fonts-dejavu-core as a test Build-Depends

 -- James McCoy <jamessan@debian.org>  Mon, 20 Mar 2023 14:36:50 -0400

neovim-qt (0.2.17-1) experimental; urgency=medium

  * New upstream release (Closes: #1032556)
  * Remove explicit setting of $HOME since dh_auto_test handles that
  * Build man page in execute_before_dh_auto_install instead of override_dh_auto_build
  * Switch to declarative alternatives
  * Override package-contains-documentation-outside-usr-share-doc for nvim_gui_shim.txt
  * Declare compliance with Policy 4.6.2, no changed needed
  * Bump watch file version to 4
  * Do not install LICENSE file, already part of d/copyright

 -- James McCoy <jamessan@debian.org>  Mon, 20 Mar 2023 11:37:04 -0400
