=== debian/control ===
Source: neovim-qt
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
Uploaders:
 Jason Pleau <jason@jpleau.ca>,
 James McCoy <jamessan@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 fonts-dejavu-core <!nocheck>,
 help2man,
 libmsgpack-dev (>= 1.4.0-2),
 libqt5svg5-dev,
 neovim,
 neovim (>= 0.3.2) | xclip,
 ninja-build,
 python3,
 python3-jinja2,
 python3-msgpack,
 qtbase5-dev,
 xauth,
 xvfb,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/equalsraf/neovim-qt
Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git
Vcs-Browser: https://salsa.debian.org/vim-team/neovim-qt

Package: neovim-qt
Architecture: any
Depends:
 neovim,
 ${misc:Depends},
 ${shlibs:Depends},
Description: neovim client library and GUI
 neovim-qt provides a Qt5 GUI interface for neovim
