=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/neovim-qt-$1\.tar\.gz/ \
  https://github.com/equalsraf/neovim-qt/tags .*/v?(\d\S*)\.tar\.gz
