## neovim-qt 0.2.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,7 @@
-cmake_minimum_required(VERSION 2.8.12)
-if (POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-endif (POLICY CMP0048)
-if (POLICY CMP0069)
-  cmake_policy(SET CMP0069 NEW)
-endif (POLICY CMP0069)
-
+cmake_minimum_required(VERSION 3.9.0)
 # Neovim-Qt Version, used by --version update before release
 # 9999 = Development Pre-Release
-project(neovim-qt VERSION 0.2.18.0)
+project(neovim-qt VERSION 0.2.19.0)
 
 if(NOT EXISTS ${NEOVIM_EXEC})
 	set(NEOVIM_EXEC nvim)
@@ -17,6 +10,7 @@
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
+option(REPRODUCIBLE_BUILD "Make this build reproducible" ON)
 option(USE_GCOV "Enable gcov support" OFF)
 option(ENABLE_CLAZY "Build with KDE Clang Clazy Linter" OFF)
 option(ENABLE_TIDY "Build with Clang Tidy Linter" OFF)
