=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 # This is a minimal CMake project to fetch and build third party
 # dependencies
-cmake_minimum_required(VERSION 2.8.12)
-if (POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-endif (POLICY CMP0048)
+cmake_minimum_required(VERSION 3.9.0)
 project(neovim-qt-deps)
 
 #
