=== src/gui/shellwidget/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
-cmake_minimum_required(VERSION 2.8.12)
-if (POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-endif (POLICY CMP0048)
+cmake_minimum_required(VERSION 3.9.0)
 project(qshellwidget)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
