=== debian/changelog ===
neovim-qt (0.2.19-1) unstable; urgency=medium

  * New upstream release
    + Exclude compilation flags from version info by default so the build is
      reproducible. (Closes: #963688)
  * Mark xfvb and xauth Build-Depends <!nocheck>
  * Declare compliance with Policy 4.7.0, no changes needed
  * Remove obsolete xclip Build-Depends
  * Add salsa-ci.yml config

 -- James McCoy <jamessan@debian.org>  Wed, 19 Feb 2025 06:55:54 -0500
