=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: neovim-qt
 Section: editors
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
+Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
 Uploaders:
  Jason Pleau <jason@jpleau.ca>,
  James McCoy <jamessan@debian.org>,
@@ -14,15 +13,14 @@
  libmsgpack-dev (>= 1.4.0-2),
  libqt5svg5-dev,
  neovim,
- neovim (>= 0.3.2) | xclip,
  ninja-build,
  python3,
  python3-jinja2,
  python3-msgpack,
  qtbase5-dev,
- xauth,
- xvfb,
-Standards-Version: 4.6.2
+ xauth <!nocheck>,
+ xvfb <!nocheck>,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/equalsraf/neovim-qt
 Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git
