=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,7 @@
 	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release -DPYTHON_EXECUTABLE=/usr/bin/python3 -DENABLE_TESTS=$(ENABLE_TEST)
 
 execute_before_dh_auto_install:
-# Workaround bug where $DISPLAY is needed for --help
-	xvfb-run --auto-servernum help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt
+	help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt
 
 execute_after_dh_auto_install:
 	rm -f $(CURDIR)/debian/neovim-qt/usr/share/nvim-qt/LICENSE
